Index: device.h
===================================================================
--- device.h	(revision 0)
+++ device.h	(revision 0)
@@ -0,0 +1,108 @@
+typedef enum {
+    QEMU_CTYPE_STR,
+    QEMU_CTYPE_BOOL,
+    QEMU_CTYPE_INT,
+    /* XXX: add array type ? */
+    /* XXX: add struct type ? */
+} QEMUTypeEnum;
+
+#define QEMU_CLASS_MAX_PARENTS 8
+
+#define QEMU_CLASS_ABSTRACT 0x0001 /* object of this class cannot be
+                                      instantiated */
+
+typedef struct QEMUDevice QEMUDevice;
+
+/* entry type definition */
+typedef struct QEMUDeviceClass {
+    char *name;
+    char *descr;
+    int flags;
+    int nb_parents;
+    struct QEMUDeviceClass *parents[QEMU_CLASS_MAX_PARENTS];
+    struct QEMUDeviceClass *next_class;
+    struct QEMUDeviceClassField *first_field;
+    /* default value for fields. Can initialize fields of parents too */
+    struct QEMUDeviceClassInitField *first_init_field;
+    
+    /* constructor */
+    int (*dev_init)(QEMUDevice *dev);
+    void (*dev_release)(QEMUDevice *dev);
+    void *opaque;
+} QEMUDeviceClass;
+
+typedef struct QEMUDeviceClassField QEMUDeviceClassField;
+
+struct QEMUDevice {
+    char *name;
+    QEMUDeviceClass *dev_class;
+    struct QEMUDevice *dev_next;
+    struct QEMUDeviceField *first_field;
+
+    void *opaque; /* opaque usable by the device model */
+    int instantiated;
+};
+
+/* class handling */
+QEMUDeviceClass *qemu_class_new(const char *name, int flags,
+                                const char *descr);
+QEMUDeviceClass *qemu_class_find(const char *name);
+int qemu_class_add_parent(QEMUDeviceClass *dc, 
+                          QEMUDeviceClass *parent);
+int qemu_class_instanceof(QEMUDeviceClass *dc1, QEMUDeviceClass *dc2);
+QEMUDeviceClassField *qemu_class_field_new(QEMUDeviceClass *dc, 
+                                           const char *name,
+                                           QEMUTypeEnum type);
+int qemu_class_set_int(QEMUDeviceClass *dc, const char *name,
+                       int64_t val);
+int qemu_class_set_bool(QEMUDeviceClass *dc, const char *name,
+                        int val);
+int qemu_class_set_str(QEMUDeviceClass *dc, const char *name,
+                       const char *str);
+
+/* device handling */
+extern QEMUDevice *qemu_first_device;
+
+QEMUDevice *qemu_device_find(const char *name);
+QEMUDevice *qemu_device_new(QEMUDeviceClass *dc, const char *name);
+QEMUDevice *qemu_device_new_after(QEMUDeviceClass *dc, const char *name,
+                                  QEMUDevice *dev1);
+QEMUDevice *qemu_device_new_nodup(QEMUDeviceClass *dc, const char *base_name);
+void qemu_device_delete(QEMUDevice *dev);
+int qemu_device_set_int(QEMUDevice *dev, const char *name, int64_t val);
+int qemu_device_set_bool(QEMUDevice *dev, const char *name, int val);
+int qemu_device_set_str(QEMUDevice *dev, const char *name, const char *str);
+int64_t qemu_device_get_int(QEMUDevice *dev, const char *name);
+int qemu_device_get_bool(QEMUDevice *dev, const char *name);
+const char *qemu_device_get_str(QEMUDevice *dev, const char *name);
+
+/* config file */
+#define QEMU_CONF_NO_OBJ   (1 << 0)
+#define QEMU_CONF_ERR_FILE (1 << 1)
+
+int qemu_parse_config(QEMUDevice **pmain_dev, const char *filename, int flags);
+
+/* params */
+const char *get_opt_name(char *buf, int buf_size, const char *p);
+const char *get_opt_value(char *buf, int buf_size, const char *p);
+int get_param_value(char *buf, int buf_size,
+                    const char *tag, const char *str);
+int qemu_device_set_params(QEMUDevice *dev, const char *opts,
+                           const char *trans_list);
+
+/* global devices / types */
+extern QEMUDevice *machine_dev;
+extern QEMUDevice *qemu_prefs;
+
+int nd_init(QEMUDevice *dev, NICInfo *nd);
+void qemu_get_machine_macaddr(uint8_t *macaddr);
+qemu_irq qemu_irq_from_name(const char *name);
+PCIBus *pci_get_bus_devfn(QEMUDevice *dev, int *pdevfn);
+void qemu_register_irqs(const char *name, qemu_irq *irqs, int nb_irqs);
+
+void do_info_devices(void);
+void do_info_classes(const char *class_name);
+
+/* debug */
+void dump_classes(void);
+void dump_devices(void);
Index: monitor.c
===================================================================
--- monitor.c	(revision 4734)
+++ monitor.c	(working copy)
@@ -223,23 +223,6 @@
     }
 }
 
-static void do_info(const char *item)
-{
-    term_cmd_t *cmd;
-
-    if (!item)
-        goto help;
-    for(cmd = info_cmds; cmd->name != NULL; cmd++) {
-        if (compare_cmd(item, cmd->name))
-            goto found;
-    }
- help:
-    help_cmd("info");
-    return;
- found:
-    cmd->handler();
-}
-
 static void do_info_version(void)
 {
   term_printf("%s\n", QEMU_VERSION);
@@ -1333,8 +1316,8 @@
       "[cmd]", "show the help" },
     { "commit", "s", do_commit,
       "device|all", "commit changes to the disk images (if -snapshot is used) or backing files" },
-    { "info", "s?", do_info,
-      "subcommand", "show various information about the system state" },
+    { "info", "s?", NULL,
+      "subcommand...", "show various information about the system state" },
     { "q|quit", "", do_quit,
       "", "quit the emulator" },
     { "eject", "-fB", do_eject,
@@ -1467,6 +1450,10 @@
     { "slirp", "", do_info_slirp,
       "", "show SLIRP statistics", },
 #endif
+    { "devices", "", do_info_devices,
+      "", "show the instantiated devices" },
+    { "classes", "s?", do_info_classes,
+      "", "show the available device types" },
     { NULL, NULL, },
 };
 
@@ -2144,15 +2131,34 @@
     memcpy(cmdname, pstart, len);
     cmdname[len] = '\0';
 
-    /* find the command */
-    for(cmd = term_cmds; cmd->name != NULL; cmd++) {
-        if (compare_cmd(cmdname, cmd->name))
-            goto found;
+    if (!strcmp(cmdname, "info")) {
+        /* info subcommands */
+        q = cmdname;
+        while (isspace(*p))
+            p++;
+        pstart = p;
+        while (*p != '\0' && !isspace(*p))
+            p++;
+        len = p - pstart;
+        if (len > sizeof(cmdname) - 1)
+            len = sizeof(cmdname) - 1;
+        memcpy(cmdname, pstart, len);
+        cmdname[len] = '\0';
+        for(cmd = info_cmds; cmd->name != NULL; cmd++) {
+            if (compare_cmd(cmdname, cmd->name))
+                goto found;
+        }
+        help_cmd("info");
+    } else {
+        /* find the command */
+        for(cmd = term_cmds; cmd->name != NULL; cmd++) {
+            if (compare_cmd(cmdname, cmd->name))
+                goto found;
+        }
+        term_printf("unknown command: '%s'\n", cmdname);
     }
-    term_printf("unknown command: '%s'\n", cmdname);
     return;
  found:
-
     for(i = 0; i < MAX_ARGS; i++)
         str_allocated[i] = NULL;
 
Index: hw/integratorcp.c
===================================================================
--- hw/integratorcp.c	(revision 4734)
+++ hw/integratorcp.c	(working copy)
@@ -518,18 +518,9 @@
         exit(1);
     }
     pl181_init(0x1c000000, drives_table[sd].bdrv, pic[23], pic[24]);
-    if (nd_table[0].vlan) {
-        if (nd_table[0].model == NULL
-            || strcmp(nd_table[0].model, "smc91c111") == 0) {
-            smc91c111_init(&nd_table[0], 0xc8000000, pic[27]);
-        } else if (strcmp(nd_table[0].model, "?") == 0) {
-            fprintf(stderr, "qemu: Supported NICs: smc91c111\n");
-            exit (1);
-        } else {
-            fprintf(stderr, "qemu: Unsupported NIC: %s\n", nd_table[0].model);
-            exit (1);
-        }
-    }
+
+    qemu_register_irqs("pic0", pic, 32);
+    smc91c111_set_defaults(0xc8000000, pic, 27);
     pl110_init(ds, 0xc0000000, pic[22], 0);
 
     integrator_binfo.ram_size = ram_size;
@@ -544,4 +535,5 @@
     "ARM Integrator/CP (ARM926EJ-S)",
     integratorcp_init,
     0x100000,
+    "smc91c111",
 };
Index: hw/ppc_chrp.c
===================================================================
--- hw/ppc_chrp.c	(revision 4734)
+++ hw/ppc_chrp.c	(working copy)
@@ -265,11 +265,7 @@
 
     /* XXX: use Mac Serial port */
     serial_init(0x3f8, dummy_irq[4], 115200, serial_hds[0]);
-    for(i = 0; i < nb_nics; i++) {
-        if (!nd_table[i].model)
-            nd_table[i].model = "ne2k_pci";
-        pci_nic_init(pci_bus, &nd_table[i], -1);
-    }
+
     if (drive_get_max_bus(IF_IDE) >= MAX_IDE_BUS) {
         fprintf(stderr, "qemu: too many IDE bus\n");
         exit(1);
@@ -329,6 +325,8 @@
 
     /* Special port to get debug messages from Open-Firmware */
     register_ioport_write(0x0F00, 4, 1, &PPC_debug_write, NULL);
+
+    qemu_register_irqs("isapic0", dummy_irq, 16);
 }
 
 QEMUMachine core99_machine = {
@@ -336,4 +334,5 @@
     "Mac99 based PowerMAC",
     ppc_core99_init,
     BIOS_SIZE + VGA_RAM_SIZE,
+    "ne2k_pci",
 };
Index: hw/arm-misc.h
===================================================================
--- hw/arm-misc.h	(revision 4734)
+++ hw/arm-misc.h	(working copy)
@@ -39,6 +39,11 @@
 
 /* stellaris_enent.c */
 void stellaris_enet_init(NICInfo *nd, uint32_t base, qemu_irq irq);
+void stellaris_enet_set_defaults(uint32_t membase, qemu_irq *pic, int irq);
 
+/* musicpal.c */
+void mv88w8618_eth_init(NICInfo *nd, uint32_t base, qemu_irq irq);
+void mv88w8618_eth_set_defaults(uint32_t membase, qemu_irq *pic, int irq);
+
 #endif /* !ARM_MISC_H */
 
Index: hw/mips_jazz.c
===================================================================
--- hw/mips_jazz.c	(revision 4734)
+++ hw/mips_jazz.c	(working copy)
@@ -75,33 +75,6 @@
     rtc_writeb,
 };
 
-#ifdef HAS_AUDIO
-static void audio_init(qemu_irq *pic)
-{
-    struct soundhw *c;
-    int audio_enabled = 0;
-
-    for (c = soundhw; !audio_enabled && c->name; ++c) {
-        audio_enabled = c->enabled;
-    }
-
-    if (audio_enabled) {
-        AudioState *s;
-
-        s = AUD_init();
-        if (s) {
-            for (c = soundhw; c->name; ++c) {
-                if (c->enabled) {
-                    if (c->isa) {
-                        c->init.init_isa(s, pic);
-                    }
-                }
-            }
-        }
-    }
-}
-#endif
-
 void espdma_memory_read(void *opaque, uint8_t *buf, int len)
 {
     printf("espdma_memory_read(buf %p, len %d) not implemented\n", buf, len);
@@ -244,9 +217,6 @@
 
     /* Sound card */
     /* FIXME: missing Jazz sound at 0x8000c000, rc4030[2] */
-#ifdef HAS_AUDIO
-    audio_init(i8259);
-#endif
 
     /* NVRAM: Unprotected at 0x9000, Protected at 0xa000, Read only at 0xb000 */
     ds1225y_init(0x80009000, "nvram");
Index: hw/sun4m.c
===================================================================
--- hw/sun4m.c	(revision 4734)
+++ hw/sun4m.c	(working copy)
@@ -366,6 +366,27 @@
     return kernel_size;
 }
 
+static void lance_dev_init(target_phys_addr_t leaddr, void *dma_opaque,
+                           qemu_irq irq, qemu_irq *reset)
+{
+    QEMUDevice *dev;
+    QEMUDeviceClass *dc;
+    NICInfo nd;
+
+    dc = qemu_class_find("lance");
+    for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+        if (dev->dev_class == dc) {
+            break;
+        }
+    }
+    if (!dev)
+        return;
+    dev->instantiated = 1;
+    if (nd_init(dev, &nd) < 0)
+        return;
+    lance_init(&nd, leaddr, dma_opaque, irq, reset);
+}
+
 static void sun4m_hw_init(const struct hwdef *hwdef, ram_addr_t RAM_size,
                           const char *boot_device,
                           DisplayState *ds, const char *kernel_filename,
@@ -385,6 +406,7 @@
     char buf[1024];
     BlockDriverState *fd[MAX_FD];
     int drive_index;
+    uint8_t macaddr[6];
 
     /* init CPUs */
     if (!cpu_model)
@@ -477,16 +499,7 @@
     tcx_init(ds, hwdef->tcx_base, phys_ram_base + RAM_size, RAM_size,
              hwdef->vram_size, graphic_width, graphic_height, graphic_depth);
 
-    if (nd_table[0].model == NULL
-        || strcmp(nd_table[0].model, "lance") == 0) {
-        lance_init(&nd_table[0], hwdef->le_base, ledma, *ledma_irq, le_reset);
-    } else if (strcmp(nd_table[0].model, "?") == 0) {
-        fprintf(stderr, "qemu: Supported NICs: lance\n");
-        exit (1);
-    } else {
-        fprintf(stderr, "qemu: Unsupported NIC: %s\n", nd_table[0].model);
-        exit (1);
-    }
+    lance_dev_init(hwdef->le_base, ledma, *ledma_irq, le_reset);
 
     nvram = m48t59_init(slavio_irq[0], hwdef->nvram_base, 0,
                         hwdef->nvram_size, 8);
@@ -539,7 +552,8 @@
     kernel_size = sun4m_load_kernel(kernel_filename, initrd_filename,
                                     RAM_size);
 
-    nvram_init(nvram, (uint8_t *)&nd_table[0].macaddr, kernel_cmdline,
+    qemu_get_machine_macaddr(macaddr);
+    nvram_init(nvram, macaddr, kernel_cmdline,
                boot_device, RAM_size, kernel_size, graphic_width,
                graphic_height, graphic_depth, hwdef->machine_id, "Sun4m");
 
@@ -565,6 +579,7 @@
     char buf[1024];
     BlockDriverState *fd[MAX_FD];
     int drive_index;
+    uint8_t macaddr[6];
 
     /* init CPU */
     if (!cpu_model)
@@ -634,16 +649,7 @@
     tcx_init(ds, hwdef->tcx_base, phys_ram_base + RAM_size, RAM_size,
              hwdef->vram_size, graphic_width, graphic_height, graphic_depth);
 
-    if (nd_table[0].model == NULL
-        || strcmp(nd_table[0].model, "lance") == 0) {
-        lance_init(&nd_table[0], hwdef->le_base, ledma, *ledma_irq, le_reset);
-    } else if (strcmp(nd_table[0].model, "?") == 0) {
-        fprintf(stderr, "qemu: Supported NICs: lance\n");
-        exit (1);
-    } else {
-        fprintf(stderr, "qemu: Unsupported NIC: %s\n", nd_table[0].model);
-        exit (1);
-    }
+    lance_dev_init(hwdef->le_base, ledma, *ledma_irq, le_reset);
 
     nvram = m48t59_init(slavio_irq[0], hwdef->nvram_base, 0,
                         hwdef->nvram_size, 2);
@@ -689,7 +695,8 @@
     kernel_size = sun4m_load_kernel(kernel_filename, initrd_filename,
                                     RAM_size);
 
-    nvram_init(nvram, (uint8_t *)&nd_table[0].macaddr, kernel_cmdline,
+    qemu_get_machine_macaddr(macaddr);
+    nvram_init(nvram, macaddr, kernel_cmdline,
                boot_device, RAM_size, kernel_size, graphic_width,
                graphic_height, graphic_depth, hwdef->machine_id, "Sun4c");
 }
@@ -1222,6 +1229,7 @@
     "Sun4m platform, SPARCstation 5",
     ss5_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 QEMUMachine ss10_machine = {
@@ -1229,6 +1237,7 @@
     "Sun4m platform, SPARCstation 10",
     ss10_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 QEMUMachine ss600mp_machine = {
@@ -1236,6 +1245,7 @@
     "Sun4m platform, SPARCserver 600MP",
     ss600mp_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 QEMUMachine ss20_machine = {
@@ -1243,6 +1253,7 @@
     "Sun4m platform, SPARCstation 20",
     ss20_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 QEMUMachine ss2_machine = {
@@ -1250,6 +1261,7 @@
     "Sun4c platform, SPARCstation 2",
     ss2_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 QEMUMachine voyager_machine = {
@@ -1257,6 +1269,7 @@
     "Sun4m platform, SPARCstation Voyager",
     vger_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 QEMUMachine ss_lx_machine = {
@@ -1264,6 +1277,7 @@
     "Sun4m platform, SPARCstation LX",
     ss_lx_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 QEMUMachine ss4_machine = {
@@ -1271,6 +1285,7 @@
     "Sun4m platform, SPARCstation 4",
     ss4_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 QEMUMachine scls_machine = {
@@ -1278,6 +1293,7 @@
     "Sun4m platform, SPARCClassic",
     scls_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 QEMUMachine sbook_machine = {
@@ -1285,6 +1301,7 @@
     "Sun4m platform, SPARCbook",
     sbook_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 static const struct sun4d_hwdef sun4d_hwdefs[] = {
@@ -1372,6 +1389,7 @@
     int ret;
     char buf[1024];
     int drive_index;
+    uint8_t macaddr[6];
 
     /* init CPUs */
     if (!cpu_model)
@@ -1450,16 +1468,7 @@
     tcx_init(ds, hwdef->tcx_base, phys_ram_base + RAM_size, RAM_size,
              hwdef->vram_size, graphic_width, graphic_height, graphic_depth);
 
-    if (nd_table[0].model == NULL
-        || strcmp(nd_table[0].model, "lance") == 0) {
-        lance_init(&nd_table[0], hwdef->le_base, ledma, *ledma_irq, le_reset);
-    } else if (strcmp(nd_table[0].model, "?") == 0) {
-        fprintf(stderr, "qemu: Supported NICs: lance\n");
-        exit (1);
-    } else {
-        fprintf(stderr, "qemu: Unsupported NIC: %s\n", nd_table[0].model);
-        exit (1);
-    }
+    lance_dev_init(hwdef->le_base, ledma, *ledma_irq, le_reset);
 
     nvram = m48t59_init(sbi_irq[0], hwdef->nvram_base, 0,
                         hwdef->nvram_size, 8);
@@ -1493,7 +1502,8 @@
     kernel_size = sun4m_load_kernel(kernel_filename, initrd_filename,
                                     RAM_size);
 
-    nvram_init(nvram, (uint8_t *)&nd_table[0].macaddr, kernel_cmdline,
+    qemu_get_machine_macaddr(macaddr);
+    nvram_init(nvram, macaddr, kernel_cmdline,
                boot_device, RAM_size, kernel_size, graphic_width,
                graphic_height, graphic_depth, hwdef->machine_id, "Sun4d");
 }
@@ -1523,6 +1533,7 @@
     "Sun4d platform, SPARCserver 1000",
     ss1000_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
 
 QEMUMachine ss2000_machine = {
@@ -1530,4 +1541,5 @@
     "Sun4d platform, SPARCcenter 2000",
     ss2000_init,
     PROM_SIZE_MAX + TCX_SIZE,
+    "lance",
 };
Index: hw/ppc_prep.c
===================================================================
--- hw/ppc_prep.c	(revision 4734)
+++ hw/ppc_prep.c	(working copy)
@@ -76,11 +76,6 @@
 static const int ide_iobase2[2] = { 0x3f6, 0x376 };
 static const int ide_irq[2] = { 13, 13 };
 
-#define NE2000_NB_MAX 6
-
-static uint32_t ne2000_io[NE2000_NB_MAX] = { 0x300, 0x320, 0x340, 0x360, 0x280, 0x380 };
-static int ne2000_irq[NE2000_NB_MAX] = { 9, 10, 11, 3, 4, 5 };
-
 //static PITState *pit;
 
 /* ISA IO ports bridge */
@@ -547,7 +542,7 @@
     nvram_t nvram;
     m48t59_t *m48t59;
     int PPC_io_memory;
-    int linux_boot, i, nb_nics1, bios_size;
+    int linux_boot, i, bios_size;
     unsigned long bios_offset;
     uint32_t kernel_base, kernel_size, initrd_base, initrd_size;
     PCIBus *pci_bus;
@@ -668,17 +663,6 @@
     rtc_init(0x70, i8259[8]);
 
     serial_init(0x3f8, i8259[4], 115200, serial_hds[0]);
-    nb_nics1 = nb_nics;
-    if (nb_nics1 > NE2000_NB_MAX)
-        nb_nics1 = NE2000_NB_MAX;
-    for(i = 0; i < nb_nics1; i++) {
-        if (nd_table[i].model == NULL
-            || strcmp(nd_table[i].model, "ne2k_isa") == 0) {
-            isa_ne2000_init(ne2000_io[i], i8259[ne2000_irq[i]], &nd_table[i]);
-        } else {
-            pci_nic_init(pci_bus, &nd_table[i], -1);
-        }
-    }
 
     if (drive_get_max_bus(IF_IDE) >= MAX_IDE_BUS) {
         fprintf(stderr, "qemu: too many IDE bus\n");
@@ -740,24 +724,26 @@
     }
 
     m48t59 = m48t59_init(i8259[8], 0, 0x0074, NVRAM_SIZE, 59);
-    if (m48t59 == NULL)
-        return;
-    sysctrl->nvram = m48t59;
+    if (m48t59) {
+        sysctrl->nvram = m48t59;
+        
+        /* Initialise NVRAM */
+        nvram.opaque = m48t59;
+        nvram.read_fn = &m48t59_read;
+        nvram.write_fn = &m48t59_write;
+        PPC_NVRAM_set_params(&nvram, NVRAM_SIZE, "PREP", ram_size, ppc_boot_device,
+                             kernel_base, kernel_size,
+                             kernel_cmdline,
+                             initrd_base, initrd_size,
+                             /* XXX: need an option to load a NVRAM image */
+                             0,
+                             graphic_width, graphic_height, graphic_depth);
+        
+        /* Special port to get debug messages from Open-Firmware */
+        register_ioport_write(0x0F00, 4, 1, &PPC_debug_write, NULL);
+    }
 
-    /* Initialise NVRAM */
-    nvram.opaque = m48t59;
-    nvram.read_fn = &m48t59_read;
-    nvram.write_fn = &m48t59_write;
-    PPC_NVRAM_set_params(&nvram, NVRAM_SIZE, "PREP", ram_size, ppc_boot_device,
-                         kernel_base, kernel_size,
-                         kernel_cmdline,
-                         initrd_base, initrd_size,
-                         /* XXX: need an option to load a NVRAM image */
-                         0,
-                         graphic_width, graphic_height, graphic_depth);
-
-    /* Special port to get debug messages from Open-Firmware */
-    register_ioport_write(0x0F00, 4, 1, &PPC_debug_write, NULL);
+    qemu_register_irqs("isapic0", i8259, 16);
 }
 
 QEMUMachine prep_machine = {
@@ -765,4 +751,5 @@
     "PowerPC PREP platform",
     ppc_prep_init,
     BIOS_SIZE + VGA_RAM_SIZE,
+    "ne2k_pci",
 };
Index: hw/mips.h
===================================================================
--- hw/mips.h	(revision 4734)
+++ hw/mips.h	(working copy)
@@ -16,6 +16,7 @@
 
 /* mipsnet.c */
 void mipsnet_init(int base, qemu_irq irq, NICInfo *nd);
+void mipsnet_set_defaults(uint32_t iobase, qemu_irq *pic, int irq_num);
 
 /* jazz_led.c */
 extern void jazz_led_init(DisplayState *ds, target_phys_addr_t base);
Index: hw/sun4u.c
===================================================================
--- hw/sun4u.c	(revision 4734)
+++ hw/sun4u.c	(working copy)
@@ -341,12 +341,6 @@
         }
     }
 
-    for(i = 0; i < nb_nics; i++) {
-        if (!nd_table[i].model)
-            nd_table[i].model = "ne2k_pci";
-        pci_nic_init(pci_bus, &nd_table[i], -1);
-    }
-
     irq = qemu_allocate_irqs(dummy_cpu_set_irq, NULL, 32);
     if (drive_get_max_bus(IF_IDE) >= MAX_IDE_BUS) {
         fprintf(stderr, "qemu: too many IDE bus\n");
@@ -381,7 +375,6 @@
                          /* XXX: need an option to load a NVRAM image */
                          0,
                          graphic_width, graphic_height, graphic_depth);
-
 }
 
 QEMUMachine sun4u_machine = {
@@ -389,4 +382,5 @@
     "Sun4u platform",
     sun4u_init,
     PROM_SIZE_MAX + VGA_RAM_SIZE,
+    "ne2k_pci",
 };
Index: hw/versatilepb.c
===================================================================
--- hw/versatilepb.c	(revision 4734)
+++ hw/versatilepb.c	(working copy)
@@ -172,7 +172,6 @@
     PCIBus *pci_bus;
     NICInfo *nd;
     int n;
-    int done_smc = 0;
     int index;
 
     if (!cpu_model)
@@ -194,18 +193,10 @@
     pl050_init(0x10007000, sic[4], 1);
 
     pci_bus = pci_vpb_init(sic, 27, 0);
-    /* The Versatile PCI bridge does not provide access to PCI IO space,
-       so many of the qemu PCI devices are not useable.  */
-    for(n = 0; n < nb_nics; n++) {
-        nd = &nd_table[n];
-        if (!nd->model)
-            nd->model = done_smc ? "rtl8139" : "smc91c111";
-        if (strcmp(nd->model, "smc91c111") == 0) {
-            smc91c111_init(nd, 0x10010000, sic[25]);
-        } else {
-            pci_nic_init(pci_bus, nd, -1);
-        }
-    }
+
+    qemu_register_irqs("pic0", sic, 32);
+    smc91c111_set_defaults(0x10010000, sic, 25);
+
     if (usb_enabled) {
         usb_ohci_init_pci(pci_bus, 3, -1);
     }
@@ -291,6 +282,9 @@
     versatile_binfo.initrd_filename = initrd_filename;
     versatile_binfo.board_id = board_id;
     arm_load_kernel(env, &versatile_binfo);
+
+    /* The Versatile PCI bridge does not provide access to PCI IO space,
+       so many of the qemu PCI devices are not useable.  */
 }
 
 static void vpb_init(ram_addr_t ram_size, int vga_ram_size,
@@ -319,10 +313,12 @@
     "versatilepb",
     "ARM Versatile/PB (ARM926EJ-S)",
     vpb_init,
+    "smc91c111",
 };
 
 QEMUMachine versatileab_machine = {
     "versatileab",
     "ARM Versatile/AB (ARM926EJ-S)",
     vab_init,
+    "smc91c111",
 };
Index: hw/mainstone.c
===================================================================
--- hw/mainstone.c	(revision 4734)
+++ hw/mainstone.c	(working copy)
@@ -125,7 +125,8 @@
     /* MMC/SD host */
     pxa2xx_mmci_handlers(cpu->mmc, NULL, mst_irq[MMC_IRQ]);
 
-    smc91c111_init(&nd_table[0], MST_ETH_PHYS, mst_irq[ETHERNET_IRQ]);
+    qemu_register_irqs("pic0", mst_irq, 16);
+    smc91c111_set_defaults(MST_ETH_PHYS, mst_irq, ETHERNET_IRQ);
 
     mainstone_binfo.kernel_filename = kernel_filename;
     mainstone_binfo.kernel_cmdline = kernel_cmdline;
@@ -149,4 +150,5 @@
     mainstone_init,
     (MAINSTONE_RAM + MAINSTONE_ROM + 2 * MAINSTONE_FLASH +
      PXA2XX_INTERNAL_SIZE) | RAMSIZE_FIXED,
+    "smc91c111",
 };
Index: hw/mips_mipssim.c
===================================================================
--- hw/mips_mipssim.c	(revision 4734)
+++ hw/mips_mipssim.c	(working copy)
@@ -176,19 +176,9 @@
     if (serial_hds[0])
         serial_init(0x3f8, env->irq[4], 115200, serial_hds[0]);
 
-    if (nd_table[0].vlan) {
-        if (nd_table[0].model == NULL
-            || strcmp(nd_table[0].model, "mipsnet") == 0) {
-            /* MIPSnet uses the MIPS CPU INT0, which is interrupt 2. */
-            mipsnet_init(0x4200, env->irq[2], &nd_table[0]);
-        } else if (strcmp(nd_table[0].model, "?") == 0) {
-            fprintf(stderr, "qemu: Supported NICs: mipsnet\n");
-            exit (1);
-        } else {
-            fprintf(stderr, "qemu: Unsupported NIC: %s\n", nd_table[0].model);
-            exit (1);
-        }
-    }
+    /* MIPSnet uses the MIPS CPU INT0, which is interrupt 2. */
+    qemu_register_irqs("isapic0", (qemu_irq *)env->irq, 8);
+    mipsnet_set_defaults(0x4200, (qemu_irq *)env->irq, 2);
 }
 
 QEMUMachine mips_mipssim_machine = {
@@ -196,4 +186,5 @@
     "MIPS MIPSsim platform",
     mips_mipssim_init,
     BIOS_SIZE + VGA_RAM_SIZE /* unused */,
+    "mipsnet",
 };
Index: hw/mcf5208.c
===================================================================
--- hw/mcf5208.c	(revision 4734)
+++ hw/mcf5208.c	(working copy)
@@ -242,22 +242,8 @@
 
     mcf5208_sys_init(pic);
 
-    if (nb_nics > 1) {
-        fprintf(stderr, "Too many NICs\n");
-        exit(1);
-    }
-    if (nd_table[0].vlan) {
-        if (nd_table[0].model == NULL
-            || strcmp(nd_table[0].model, "mcf_fec") == 0) {
-            mcf_fec_init(&nd_table[0], 0xfc030000, pic + 36);
-        } else if (strcmp(nd_table[0].model, "?") == 0) {
-            fprintf(stderr, "qemu: Supported NICs: mcf_fec\n");
-            exit (1);
-        } else {
-            fprintf(stderr, "qemu: Unsupported NIC: %s\n", nd_table[0].model);
-            exit (1);
-        }
-    }
+    qemu_register_irqs("pic0", pic, 64);
+    mcf_fec_set_defaults(0xfc030000, pic, 36);
 
     /*  0xfc000000 SCM.  */
     /*  0xfc004000 XBS.  */
Index: hw/stellaris.c
===================================================================
--- hw/stellaris.c	(revision 4734)
+++ hw/stellaris.c	(working copy)
@@ -1088,7 +1088,8 @@
     int flash_size;
     i2c_bus *i2c;
     int i;
-
+    uint8_t macaddr[6];
+    
     flash_size = ((board->dc0 & 0xffff) + 1) << 1;
     sram_size = (board->dc0 >> 18) + 1;
     pic = armv7m_init(flash_size, sram_size, kernel_filename, cpu_model);
@@ -1105,7 +1106,8 @@
         }
     }
 
-    stellaris_sys_init(0x400fe000, pic[28], board, nd_table[0].macaddr);
+    qemu_get_machine_macaddr(macaddr);
+    stellaris_sys_init(0x400fe000, pic[28], board, macaddr);
 
     for (i = 0; i < 7; i++) {
         if (board->dc4 & (1 << i)) {
@@ -1150,9 +1152,10 @@
             pl022_init(0x40008000, pic[7], NULL, NULL);
         }
     }
+    qemu_register_irqs("pic0", pic, 64);
     if (board->dc4 & (1 << 28)) {
         /* FIXME: Obey network model.  */
-        stellaris_enet_init(&nd_table[0], 0x40048000, pic[42]);
+        stellaris_enet_set_defaults(0x40048000, pic, 42);
     }
     if (board->peripherals & BP_GAMEPAD) {
         qemu_irq gpad_irq[5];
@@ -1190,6 +1193,7 @@
     "Stellaris LM3S811EVB",
     lm3s811evb_init,
     (64 * 1024 + 8 * 1024) | RAMSIZE_FIXED,
+    "stellaris_enet",
 };
 
 QEMUMachine lm3s6965evb_machine = {
@@ -1197,4 +1201,5 @@
     "Stellaris LM3S6965EVB",
     lm3s6965evb_init,
     (256 * 1024 + 64 * 1024) | RAMSIZE_FIXED,
+    "stellaris_enet",
 };
Index: hw/mcf.h
===================================================================
--- hw/mcf.h	(revision 4734)
+++ hw/mcf.h	(working copy)
@@ -14,6 +14,7 @@
 
 /* mcf_fec.c */
 void mcf_fec_init(NICInfo *nd, target_phys_addr_t base, qemu_irq *irq);
+void mcf_fec_set_defaults(uint32_t membase, qemu_irq *pic, int irq);
 
 /* mcf5206.c */
 qemu_irq *mcf5206_init(uint32_t base, CPUState *env);
Index: hw/realview.c
===================================================================
--- hw/realview.c	(revision 4734)
+++ hw/realview.c	(working copy)
@@ -119,17 +119,10 @@
             continue;
         lsi_scsi_attach(scsi_hba, drives_table[index].bdrv, n);
     }
-    for(n = 0; n < nb_nics; n++) {
-        nd = &nd_table[n];
-        if (!nd->model)
-            nd->model = done_smc ? "rtl8139" : "smc91c111";
-        if (strcmp(nd->model, "smc91c111") == 0) {
-            smc91c111_init(nd, 0x4e000000, pic[28]);
-        } else {
-            pci_nic_init(pci_bus, nd, -1);
-        }
-    }
 
+    qemu_register_irqs("pic0", pic, 32);
+    smc91c111_set_defaults(0x4e000000, pic, 28);
+
     /* Memory map for RealView Emulation Baseboard:  */
     /* 0x10000000 System registers.  */
     /*  0x10001000 System controller.  */
@@ -200,5 +193,6 @@
     "realview",
     "ARM RealView Emulation Baseboard (ARM926EJ-S)",
     realview_init,
-    0x1000
+    0x1000,
+    "smc91c111",
 };
Index: hw/boards.h
===================================================================
--- hw/boards.h	(revision 4734)
+++ hw/boards.h	(working copy)
@@ -16,6 +16,7 @@
     QEMUMachineInitFunc *init;
 #define RAMSIZE_FIXED	(1 << 0)
     ram_addr_t ram_require;
+    const char *default_nic_model;
     struct QEMUMachine *next;
 } QEMUMachine;
 
Index: hw/ppc_oldworld.c
===================================================================
--- hw/ppc_oldworld.c	(revision 4734)
+++ hw/ppc_oldworld.c	(working copy)
@@ -289,12 +289,6 @@
     /* XXX: use Mac Serial port */
     serial_init(0x3f8, dummy_irq[4], 115200, serial_hds[0]);
 
-    for(i = 0; i < nb_nics; i++) {
-        if (!nd_table[i].model)
-            nd_table[i].model = "ne2k_pci";
-        pci_nic_init(pci_bus, &nd_table[i], -1);
-    }
-
     /* First IDE channel is a CMD646 on the PCI bus */
 
     if (drive_get_max_bus(IF_IDE) >= MAX_IDE_BUS) {
@@ -364,6 +358,8 @@
 
     /* Special port to get debug messages from Open-Firmware */
     register_ioport_write(0x0F00, 4, 1, &PPC_debug_write, NULL);
+    
+    qemu_register_irqs("isapic0", dummy_irq, 16);
 }
 
 QEMUMachine heathrow_machine = {
@@ -371,4 +367,5 @@
     "Heathrow based PowerMAC",
     ppc_heathrow_init,
     BIOS_SIZE + VGA_RAM_SIZE,
+    "ne2k_pci",
 };
